#!/bin/sh

# Copyright (C) 2010
# SAS Institute Inc., Cary, N.C. 27513, U.S.A.  All rights reserved.
#
# sort csv file on the primary key
# usage: sort_csv.sh <captain folder> <quoted csv table/file:sort_key list> [<parallel degree>]
#        sample csv file list: "mpln_geo_prod_agg/mpln_geo_prod_agg_1001.csv:'-n_-k_1,1_-k_2,2_-k_3,3_-k_4,4_-u' mpln_geo_prod_mts/mpln_geo_prod_mts_1001.csv:'-n_-k_1,1_-k_2,2_-k_3,3_-k_4,4_-u'"
#
# Author: Eric Yang, Min Zhong

if [ $# -lt 2 ]; then
    echo "usage: sort_csv.sh <captain folder> <quoted csv table/file:sort_key list> [<parallel degree(default=10)>]"
    exit 1
fi

CPT_DIR=$1
TABLE_FILE_KEY_LIST=$2
PARALLEL_DEGREE=10
if [ $# -gt 2 ]; then
  PARALLEL_DEGREE=$3 
fi

echo "sorting..."
for item in $TABLE_FILE_KEY_LIST
do
  table=${item%%/*}
  filekey=${item##*/}
  file=${filekey%%:*}
  key=$( echo ${filekey##*:} | tr '_' ' ')

  test -r $CPT_DIR/$table/$file || continue
  echo "$key -o $CPT_DIR/$table/$file $CPT_DIR/$table/$file"
done | LANG=en_US xargs -P $PARALLEL_DEGREE -L 1 sort -t ',' 

echo "sort_csv.sh finished successfully"


